#include "DHT.h" //libreria que corresponde al sensor de temperatura
#define DHTPIN 7 //se asigna un nombre al valor constante y se especifica que se encuentra en el pin 7
#define DHTTYPE DHT11//el tipo de sensor que se está utilizando

DHT dht(DHTPIN, DHTTYPE);//se relacionan ambas variables del sensor

//variables PMW que en las que cada color está conectado
int rojo = 11;//pin en el que se encuentra el componenente Rojo del led RGB
int azul = 9;//pin en el que se encuentra el componenente azul del led RGB
int verde = 10;//pin en el que se encuentra el componenente verde del led RGB
int r = 0;//se iguala a cero para que se capaz de tomar cualquier valor al leer la temperatura y humedad
int v = 0;//se iguala a cero para que se capaz de tomar cualquier valor " "
int a = 0;//se iguala a cero para que se capaz de tomar cualquier valor " "


const int pot1 = A1;//Se asigna un nombre al potenciometro y se especifica el pin en el que está ubicado
  const int pot2 = A2;//" "
  const int pot3 = A3;//" "

//variables auxiliares
  int POTA1;//valores analogos que se obtienen con la ,manipulación de los potenciometros
  int POTB1;//" "
  int POTC1;//" "

  const int buttonPin = 12; //pin en el que se ubica el botón
  int buttonState = 0;
  int lastButtonState = 0;
  int count = 0;

void setup() {
   Serial.begin(9600);//se inicia el monitor serial
  dht.begin();//lectura del sensor de temperatura y humedad
  
}

void loop() {
  buttonState = digitalRead(buttonPin);//lectura del botón
  if (buttonState ==HIGH && lastButtonState ==LOW){
    if (count == 0){
      manual();//inicia en modo manual
      count = 1;//al presionar una vez
    } else {
      automatico();//cambia al estado automático
      count = 0;
    }
  }

lastButtonState = buttonState;
  if (count== 0){
    manual();
  } else{
    automatico();
  }
}
 void manual(){
 //lectura de los potenciómetros 
  POTA1 = analogRead(pot1);
  POTB1 = analogRead(pot2);
  POTC1 = analogRead(pot3);
  
//"Mapeo" de los potenciómetros
   POTA1 = map(POTA1, 0, 1023, 0, 255);
   POTB1 = map(POTB1, 0, 1023, 0, 255);
   POTC1 = map(POTC1, 0, 1023, 0, 255);

//comandos de salida que hacen que el led encienda de acuerdo a la posición del potenciómetro
   analogWrite(rojo, POTA1);
   analogWrite(verde, POTB1);
   analogWrite(azul, POTC1);
 }

 void automatico(){
   delay(2000);
  int h = dht.readHumidity();//lectura de humedad
  int t = dht.readTemperature();//lectura de temperatura
  int n;
  int m;
  byte numero[10][3]; //almacena un número sin signo de 8 bits, de 0 a 255
  numero[0][0] = B01111100; //accede a los caracteres individuales de una cadena
  numero[0][1] = B01000100;
  numero[0][2] = B01111100;
  numero[1][0] = B00000100;
  numero[1][1] = B01111100;
  numero[1][2] = B00100100;
  numero[2][0] = B01110100;
  numero[2][1] = B01010100;
  numero[2][2] = B01011100;
  numero[3][0] = B01111100;
  numero[3][1] = B01010100;
  numero[3][2] = B01000100;
  numero[4][0] = B01111100;
  numero[4][1] = B00010000;
  numero[4][2] = B01110000;
  numero[5][0] = B01011100;
  numero[5][1] = B01010100;
  numero[5][2] = B01110100;
  numero[6][0] = B01011100;
  numero[6][1] = B01010100;
  numero[6][2] = B01111100;
  numero[7][0] = B01111100;
  numero[7][1] = B01000000;
  numero[7][2] = B01000000;
  numero[8][0] = B01111100;
  numero[8][1] = B01010100;
  numero[8][2] = B01111100;
  numero[9][0] = B01111100;
  numero[9][1] = B01010100;
  numero[9][2] = B01110100;

//si se cumple una de las condiciones se muestra un mensaje de error
  if (isnan(h) || isnan(t)) 
  {
    Serial.println("No se pudo leer desde el sensor DHT11!");
    return;
  }

  //calcular el indice de calor en grados centígrados
  int hic = dht.computeHeatIndex(t, h, false);

  n = t/10;
  m = t - n*10;

  Serial.println(t);
  control(t);
}

void control(int t)
{
  int r2,v2,a2;
  //se realizan los cálculos para cambiar las intensidades de los colores según el cambio de temperatura
  if(t<=5)
  {
    r2 = 150;
    v2 = 150;
    a2 = 150;
  }
  else if(t>35)
  {
    r2 = 255;
    v2 = 0;
    a2 = 0;
  }
  else if(t>5 && t<=10)
  {
    r2 = t*10+100;
    v2 = t*15;
    a2 = t*15+100;
  }
  else if(t>30 && t<=35)
  {
    r2 = (t-30)*10+200;
    v2 = 50-(t-30)*10;
    a2 = 0;
  }
  else if(t>25 && t<=30)
  {
    r2 = 250-10*(t-25);
    v2 = 150-20*(t-25);
    a2 = 0;
  }
  else if(t>20 && t<=25)
  {
    r2 = 50*(t-20);
    v2 = 250-20*(t-20);
    a2 = 0;
  }
  else if(t>15 && t<=20)
  {
    if(t == 16)
    {
      r2 = 150;
      v2 = 0;
      a2 = 200;
    }
    else if(t == 17)
    {
      r2 = 250;
      v2 = 0;
      a2 = 200;
    }
    else if(t == 18)
    {
      r2 = 0;
      v2 = 0;
      a2 = 250;
    }
    else if(t == 19)
    {
      r2 = 50;
      v2 = 250;
      a2 = 50;
    }
    else
    {
      r2 = 0;
      v2 = 250;
      a2 = 0;
    }
  }
  else if(t>10 && t<=15)
  {
    r2 = 200-20*(t-10);
    v2 = 150-30*(t-10);
    a2 = 250;
  }
  else
  {
    r2 = 0;
    v2 = 0;
    a2 = 0;
  }

  if(r==r2 && v==v2 && a==a2)
    Serial.println("La temperatura no a cambiado");
  else
    color(r2,v2,a2);
}

void color(int r2,int v2,int a2)
{
  int i;
  int nega[3];
  int mayor=0;
  int temp[3];
  int men1;
  int men2;

  
  temp[0] = r2-r;
  temp[1] = v2-v;
  temp[2] = a2-a;

  for(i=0;i<3;i++)
  {
    if(temp[i] < 0)
    {
      temp[i] = -1*temp[i];
      nega[i] = 1;
    }
    else
      nega[i] = 0;
  }

  for(i=0;i<3;i++)
    if(mayor<temp[i])
      mayor = temp[i];

  for(i=0;i<mayor;i++)
  {
    analogWrite(rojo, r);
    analogWrite(verde, v);
    analogWrite(azul, a);

    if(mayor == temp[0])
    {
      men1 = mayor/temp[1];
      men2 = mayor/temp[2];
      if(i%men1 == 0 && v!=v2)
        if(nega[1] == 0)
          v++; //incremento
        else
          v--; //decremento
          
      if(i%men2 == 0 && a!=a2)
        if(nega[2] == 0)
          a++;
        else
          a--;

      if(nega[0] == 0)
        r++;
      else
        r--;
    }
    
    else if(mayor == temp[1])
    {
      men1 = mayor/temp[0];
      men2 = mayor/temp[2];
      if(i%men1 == 0 && r!=r2)
        if(nega[0] == 0)
          r++;
        else
          r--;
        
      if(i%men2 == 0 && a!=a2)
        if(nega[2] == 0)
          a++;
        else
          a--;

      if(nega[1] == 0)
        v++;
      else
        v--; 
    }
    
    else
    {
      men1 = mayor/temp[0];
      men2 = mayor/temp[1];
      if(i%men1 == 0 && r!=r2)
        if(nega[0] == 0)
          r++;
        else
          r--;
        
      if(i%men2 == 0 && v!=v2)
        if(nega[1] == 0)
          v++;
        else
          v--;

      if(nega[2] == 0)
        a++;
      else
        a--;
    }

    delay(15);
  }
}
  
